"""Things

Revision ID: 0458af1a64ff
Revises: 843ec191b2d9
Create Date: 2025-03-08 14:04:48.169945+00:00

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision: str = '0458af1a64ff'
down_revision: Union[str, None] = '843ec191b2d9'
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('thingtyp',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=40), nullable=False),
    sa.Column('comment', sa.String(length=200), nullable=True),
    sa.Column('parent_id', sa.Integer(), nullable=True),
    sa.Column('abstract', sa.Boolean(), server_default='0', nullable=False, comment='Must be False for instantiating things with this type'),
    sa.ForeignKeyConstraint(['parent_id'], ['thingtyp.id'], name='fk_thingtyp_typ'),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('name')
    )
    op.create_table('thing',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('typ_id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=40), nullable=False),
    sa.Column('descr', sa.String(length=200), nullable=True),
    sa.Column('comment', sa.String(length=200), nullable=True),
    sa.Column('box_id', sa.Integer(), nullable=True),
    sa.Column('pos_x', sa.Integer(), nullable=True, comment='X position in parent'),
    sa.Column('pos_y', sa.Integer(), nullable=True, comment='Y position in parent'),
    sa.Column('pos_z', sa.Integer(), nullable=True, comment='Z position in parent'),
    sa.ForeignKeyConstraint(['box_id'], ['box.id'], name='fk_thing_box'),
    sa.ForeignKeyConstraint(['typ_id'], ['thingtyp.id'], name='fk_thing_typ'),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('name')
    )
    op.add_column('boxtyp', sa.Column('usable', sa.Boolean(), server_default='1', nullable=False, comment='Can you put things directly into this?'))
    op.add_column('label', sa.Column('thing_id', sa.Integer(), nullable=True))
    op.create_foreign_key('fk_label_thing', 'label', 'box', ['thing_id'], ['id'])
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint('fk_label_box', 'label', type_='foreignkey')
    op.drop_column('label', 'thing_id')
    op.drop_column('boxtyp', 'usable')
    op.drop_table('thing')
    op.drop_table('thingtyp')
    # ### end Alembic commands ###
